## python-fastrlock 0.8.2

=== Makefile ===
PYTHON2?=python
PYTHON?=python3
SETUPFLAGS=
PACKAGENAME=fastrlock
VERSION=$(shell python -c 'import re; f=open("fastrlock/__init__.py"); print(re.search("__version__\s*=\s*[\x27\x22](.+)[\x27\x22]", f.read()).group(1)); f.close()')

PYTHON_WITH_CYTHON=$(shell $(PYTHON)  -c 'import Cython.Compiler' >/dev/null 2>/dev/null && echo " --with-cython" || true)
PY2_WITH_CYTHON=$(shell $(PYTHON2) -c 'import Cython.Compiler' >/dev/null 2>/dev/null && echo " --with-cython" || true)

# manylinux1 images still include Python 2.7
MANYLINUX_IMAGES= \
	manylinux1_x86_64 \
	manylinux1_i686 \
    manylinux_2_24_x86_64 \
    manylinux_2_24_i686 \
    manylinux_2_24_aarch64 \
    manylinux_2_28_x86_64 \
    manylinux_2_28_aarch64 \
    musllinux_1_1_x86_64 \
    musllinux_1_1_aarch64

.PHONY: all version inplace sdist build clean wheel_manylinux wheel

all: inplace


version:
	@echo $(VERSION)

inplace:
	$(PYTHON) setup.py $(SETUPFLAGS) build_ext -i $(PYTHON_WITH_CYTHON)

sdist dist/$(PACKAGENAME)-$(VERSION).tar.gz:
	$(PYTHON) setup.py $(SETUPFLAGS) sdist $(PYTHON_WITH_CYTHON)

build:
	$(PYTHON) setup.py $(SETUPFLAGS) build $(PYTHON_WITH_CYTHON)

wheel:
	$(PYTHON) setup.py $(SETUPFLAGS) bdist_wheel $(PYTHON_WITH_CYTHON)

qemu-user-static:
	docker run --rm --privileged hypriot/qemu-register

wheel_manylinux: sdist $(addprefix wheel_,$(MANYLINUX_IMAGES))
$(addprefix wheel_,$(filter-out %_x86_64, $(filter-out %_i686, $(MANYLINUX_IMAGES)))): qemu-user-static

wheel_%: dist/$(PACKAGENAME)-$(VERSION).tar.gz
	echo "Building wheels for $(PACKAGENAME) $(VERSION)"
	mkdir -p wheelhouse_$(subst wheel_,,$@)
	time docker run --rm -t \
		-v $(shell pwd):/io \
		-e CFLAGS="-O3 -g1 -mtune=generic -pipe -fPIC" \
		-e LDFLAGS="$(LDFLAGS) -fPIC" \
		-e WHEELHOUSE=wheelhouse_$(subst wheel_,,$@) \
		quay.io/pypa/$(subst wheel_,,$@) \
		bash -c '\
			rm -fr $(PACKAGENAME)-$(VERSION)/; \
			tar zxf /io/$< && cd $(PACKAGENAME)-$(VERSION)/ || exit 1; \
			for PYBIN in /opt/python/cp*/bin; do \
				PYVER="$$($$PYBIN/python -V)"; \
				PROFDIR="prof-$${PYVER// /_}"; \
				echo $$PYVER; \
				$$PYBIN/pip install -U pip setuptools; \
				make clean; rm -fr $$PROFDIR; \
				CFLAGS="$$CFLAGS -fprofile-generate -fprofile-dir=$$PROFDIR" $$PYBIN/python setup.py build_ext -i; \
				$$PYBIN/python lockbench.py flock quick; \
				CFLAGS="$$CFLAGS -fprofile-use -fprofile-correction -fprofile-dir=$$PROFDIR" $$PYBIN/python setup.py build_ext -i -f; \
				$$PYBIN/python lockbench.py rlock flock quick; \
				CFLAGS="$$CFLAGS -fprofile-use -fprofile-correction -fprofile-dir=$$PROFDIR" $$PYBIN/python setup.py bdist_wheel; \
		    done; \
		    for whl in dist/$(PACKAGENAME)-$(VERSION)-*-linux_*.whl; do auditwheel repair $$whl -w /io/$$WHEELHOUSE; done; \
		    '

clean:
	find . \( -name '*.o' -o -name '*.so' -o -name '*.py[cod]' -o -name '*.dll' \) -exec rm -f {} \;
	rm -rf build

=== requirements.txt ===
Cython>=3.0.2
setuptools
wheel

=== debian/changelog ===
python-fastrlock (0.8.2-1) unstable; urgency=medium

  * Initial release.

 -- Mo Zhou <lumin@debian.org>  Sun, 13 Oct 2024 01:28:45 -0400

=== debian/control ===
Source: python-fastrlock
Section: python
Homepage: https://github.com/scoder/fastrlock
Priority: optional
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/science-team/python-fastrlock.git
Vcs-Browser: https://salsa.debian.org/science-team/python-fastrlock
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cython3,
               debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-all-dev

Package: python3-fastrlock
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: fast RLock implementation for CPython
 This is a C-level implementation of a fast, re-entrant, optimistic lock for
 CPython. It is a drop-in replacement for threading.RLock. FastRLock is
 implemented in Cython and also provides a C-API for direct use from Cython code
 via from fastrlock cimport rlock or from cython.cimports.fastrlock import
 rlock.

## python-fastrlock 0.8.3

=== Makefile ===
--- 
+++ 
@@ -8,6 +8,7 @@
 PY2_WITH_CYTHON=$(shell $(PYTHON2) -c 'import Cython.Compiler' >/dev/null 2>/dev/null && echo " --with-cython" || true)
 
 # manylinux1 images still include Python 2.7
+MANYLINUX_PYTHON?=cp*
 MANYLINUX_IMAGES= \
 	manylinux1_x86_64 \
 	manylinux1_i686 \
@@ -57,7 +58,7 @@
 		bash -c '\
 			rm -fr $(PACKAGENAME)-$(VERSION)/; \
 			tar zxf /io/$< && cd $(PACKAGENAME)-$(VERSION)/ || exit 1; \
-			for PYBIN in /opt/python/cp*/bin; do \
+			for PYBIN in /opt/python/$(MANYLINUX_PYTHON)/bin; do \
 				PYVER="$$($$PYBIN/python -V)"; \
 				PROFDIR="prof-$${PYVER// /_}"; \
 				echo $$PYVER; \

=== requirements.txt ===
Cython>=3.0.11, <3.1
setuptools
wheel

=== debian/changelog ===
python-fastrlock (0.8.3-2build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:38:54 +0000

python-fastrlock (0.8.3-2) unstable; urgency=medium

  * Add missing B-D python3-setuptools. (Closes: #1100266)

 -- Mo Zhou <lumin@debian.org>  Tue, 18 Mar 2025 23:41:56 -0400

python-fastrlock (0.8.3-1) unstable; urgency=medium

  * New upstream version 0.8.3

 -- Mo Zhou <lumin@debian.org>  Sun, 02 Mar 2025 14:28:35 -0500

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,8 @@
                debhelper-compat (= 13),
                dh-python,
                python3-all,
-               python3-all-dev
+               python3-all-dev,
+               python3-setuptools,
 
 Package: python3-fastrlock
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME = fastrlock
%:
	dh $@ --with python3 --buildsystem=pybuild

execute_after_dh_auto_clean:
	-$(RM) fastrlock/rlock.c

=== debian/tests/control ===
Test-Command: python3 fastrlock/tests/test_rlock.py -v
Depends: @
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
https://github.com/scoder/fastrlock/releases \
(?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
